# ////////////////////////////////////////////////////////////////////////////////
# // login.tcl ///////////////////////////////////////////////////////////////////
# ////////////////////////////////////////////////////////////////////////////////

#
# //
# // Event Monitor Project
# // version 0.6
# //
# // Juan Manuel Casillas
# // assman@gsyc.inf.uc3m.es
# //
# //
# // Event Monitor Project
# //
# // login.tcl
# //
# //
# // test the password of the user and let it
# // go into the system.
# //
# // This program part of Event Monitor Project (EM), 
# // a system to manage and operate a heterogeneous 
# // network, based on message-passing.
# // See License file for details
# //
# // 
# //
# // Some documentation written on spanish. Sorry
# // a lot. I will translate it as soon as possible
# //
#
#
# Este fichero implementa un conjunto de funciones para implementar
# una ventana de login en la que autenticar a un usuario. Para ello se 
# necesita un fichero de claves en las que se encuentra una linea con
# dos campos separada por espacios y/o tabuladores, la primera el login
# y la segunda el password. Por ahora no estn cifrados. Utiliza la 
# libreria TIX
#
# Variables Globales
# ^^^^^^^^^^^^^^^^^^
#
#
# Procedimientos
# ^^^^^^^^^^^^^^
#
#	Login:Text { login passwd fich }   Comprueba si el login y el password
#					   existen en el fichero fich y son 
#					   iguales a los introducidos. devuelve
#	                                   1 en este caso (correcto) y 0 si no.				  
# 
#	Login:Check { fich }               Genera una nueva ventana y pide al
#                                          usuario el login y el password. En 
#                                          de pulsar cancelar, devuelve un 0, si
#                                          se pulsa aceptar y el login y el passwd
#                                          son validos, devuelve un uno. Se 
#                                          destruye la pantalla en caso de que la
#                                          autorizacion sea valida o se pulse
#                                          cancelar.
#
#
# POR HACER
#
# - cifrado de passwords
#
# ////////////////////////////////////////////////////////////////////////////////
# // version 0.1                //////////////////////////////////////////////////
# // jcasilla.madrid@sinvest.es //////////////////////////////////////////////////
# ////////////////////////////////////////////////////////////////////////////////

# ////////////////////////////////////////////////////////////////////////////////
# // Login:Test() ////////////////////////////////////////////////////////////////
# ////////////////////////////////////////////////////////////////////////////////

proc Login:Test { login passwd  } {

    global PASS_FILE
    set f [ open $PASS_FILE r ]
    set n 4
  while { [gets $f cadena] >= 0} {
      set haz [ regexp $login $cadena ]
      scan $cadena "%s %s" log pass
      if { [ expr $log == $login && $pass == $passwd] } {
		close $f
		return 1
	    }
  }
  close $f
  return 0
}

# ////////////////////////////////////////////////////////////////////////////////
# // Login:Check() ///////////////////////////////////////////////////////////////
# ////////////////////////////////////////////////////////////////////////////////

proc Login:Check { OK } {
    global ACEPT_COMMAND
    upvar $OK ok 
    set w .passwd

    toplevel $w

    #
    # Creamos un frame y el widget ScrolledHList
    # en la ventana de dialogo
    #

    wm minsize $w 400 200
    wm title $w "Access Control"

    frame $w.main -relief raised -bd 1
    frame $w.main.top -relief raised -bd 1
    frame $w.main.bot -relief raised -bd 1

    set top $w.main.top
    set bot $w.main.bot

   #
   # etiquetilla de la parte superior 
   #

   label $top.lr -text "" -anchor nw 
   label $top.lt -text "Access Control" -anchor nw  -padx 10
   label $top.l2 -text "Insert Password" -anchor nw -padx 10
   label $top.l3 -text "" -anchor nw 	
   pack $top.lr $top.lt $top.l2  $top.l3 -side top -fill x 
 
   label $bot.f0 -text "  " -pady 2
   frame $bot.f1 -relief flat
   frame $bot.f2 -relief flat
   label $bot.f4 -text "  " 
   frame $bot.f3 -relief flat
   label $bot.f5 -text "  " 

   #
   # entradas y etiquetas
   #	

   set login ""
   set password ""
 
   entry $bot.f1.e1 -textvariable "login" -width 20 
   label $bot.f1.l1 -text Login -anchor ne -padx 10 -pady 5
   label $bot.f1.l2 -text "  "
   entry $bot.f2.e1 -textvariable "password" -width 20 -show * 
   label $bot.f2.l1 -text Password -anchor ne -padx 10 -pady 5
   label $bot.f2.l2 -text "  "

   pack $bot.f1.l2 $bot.f1.e1 $bot.f1.l1 -side right -fill x
   pack $bot.f2.l2 $bot.f2.e1 $bot.f2.l1 -side right -fill x

   #
   # botones
   #

   button $bot.f3.b1 -text "Acept" -command { 
        set ok [ Login:Test $login $password ]
	if { $ok == "1" } {
	    destroy .passwd

	}}

   button $bot.f3.b2 -text "Cancel" -command {
        #set ok 0
        #return $ok
#        destroy .passwd
	exit
   } 
   
   label $bot.f3.l0 -text " "
   pack $bot.f3.l0 $bot.f3.b1 $bot.f3.b2 -side right
   pack $bot.f0 $bot.f1 $bot.f2 $bot.f4 $bot.f3 $bot.f5 -side top -fill x

   pack $w.main.top -side top -fill x 
   pack $w.main.bot -side bottom -fill both -expand yes
   pack $w.main -expand yes -fill both

   grab $w
   tkwait window $w
}

