/* //////////////////////////////////////////////////////////////////////// */
/* // send_message.c ////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */


//
// Event Monitor Project
// version 0.6
//
// Juan Manuel Casillas
// assman@gsyc.inf.uc3m.es
//
//
// 
// emlib [ Aka Event Monitor Library ]
//
// this library provides you an API for send messages to the
// server from inside programs written in C.
//
// 
// This program is part of Event Monitor project (EM), 
// a system to manage and operate a heterogeneous 
// network, based on message-passing.
// See License file for details
//



#include <stdio.h>
#include <stdlib.h>

#include <string.h>
#include <strings.h>
#include <ctype.h>
#include <unistd.h>
#include <time.h>

#include "emutil.h"

/* //////////////////////////////////////////////////////////////////////// */
/* // generate_message() ////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */

void generate_message(int level, char *group, char *buff, char *msg) {
  int p;
  char fecha[MAX_CAD];
  char hname[MAX_CAD];
  
  p=(int)time(NULL);
  bzero(fecha,sizeof(fecha));  
  strftime(fecha,sizeof(fecha),"%D %H:%M:%S",localtime((time_t *)&p));
  bzero(msg,MAX_CAD);
  
  bzero(hname,sizeof(hname));   
  gethostname(hname,sizeof(hname));    
  sprintf(msg,"%d %s %s %s %s",level,hname,fecha,group,buff);
}


/* //////////////////////////////////////////////////////////////////////// */
/* // send_menssage() ///////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */

int send_message(char *host, long port, int level, char *group, char *msg) {
  char buffer[MAX_BUFFER];
  char hname[MAX_CAD];

  if ((level<0) || (level>9)) error(10,NULL);

  bzero(hname,sizeof(hname));   /* extraigo el nombre del host donde estoy */
  gethostname(hname,sizeof(hname));    

  generate_message(level,group,msg,buffer);
  return(send_data(buffer,hname,host,port));
}

/* //////////////////////////////////////////////////////////////////////// */
/* // send_message_raw() ////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */


int send_message_raw(char *host, long port, char *msg) {
  char hname[MAX_CAD];

  bzero(hname,sizeof(hname));   /* extraigo el nombre del host donde estoy */
  gethostname(hname,sizeof(hname));    

  return(send_data(msg,hname,host,port));
}



