/* //////////////////////////////////////////////////////////////////////// */
/* // emsrvmsg.c ////////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */

//
// Event Monitor Project
// version 0.6
//
// Juan Manuel Casillas
// assman@gsyc.inf.uc3m.es
//
//
// 
// emsrvmsg [ Aka Event Server Message ]
//
// this program receives messages for the managed nodes and stores
// them on a plain file. Next, another servers and process works
// on it and adds more functionality
//
// This program is part of Event Monitor project(EM), 
// a system to manage and operate a heterogeneous 
// network, based on message-passing.
// See License file for details
//
//
// Usage: emsrvmsg &
//

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <signal.h>
#include <netdb.h>
#include <string.h>
#include <netinet/in.h>
#include <unistd.h>
#include <strings.h>
#include <time.h>

#include "libem.h"

/* //////////////////////////////////////////////////////////////////////// */
/* // save_data() ///////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */

void save_data(char *FICH, char *buffer, long id) {
FILE *f;
    f=NULL;
f=fopen(FICH,"a");
if (f==NULL) error(9,FICH);
     fprintf(f,"%ld %s\n",id,buffer);
fclose(f);
}

/* //////////////////////////////////////////////////////////////////////// */
/* // load() ////////////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */

void load(char *CF, char *FLOG, int *PORT) {
FILE *f=NULL;
char cad[MAX_CAD];
f=fopen(CF,"r");

if (f==NULL) error(9,CF);
bzero(FLOG,MAX_CAD);
   read_cad(f,cad);
   if (sscanf(cad,"%d",PORT)!=1) error(8,CF);
   read_cad(f,cad);
   if (sscanf(cad,"%s",FLOG)!=1) error(8,CF);
fclose(f);
}


/* //////////////////////////////////////////////////////////////////////// */
/* // main() ////////////////////////////////////////////////////////////// */
/* //////////////////////////////////////////////////////////////////////// */


void main(int argc, char *argv[]) {
  char hname[MAX_CAD];
  int socketfd;
  int new_socketfd;
  struct hostent *host;
  struct sockaddr_in cli_address;
  int cli_size;
  char buffer[MAX_BUFFER];
  int nport;
  int n;
  int childpid;
  char *FFLOG;
  char FLOG[MAX_CAD];
  long id=0;
  char dir2[ADDR_LEN];
     
  id=time(NULL);

  bzero(hname,sizeof(hname));   /* extraigo el nombre del host donde estoy */
  gethostname(hname,sizeof(hname));    

  FFLOG=getenv(ENV_VAR_DIR);
  if (FFLOG==NULL) load(CFILE,FLOG,&nport);
  else load(FFLOG,FLOG,&nport);

     
  if (argc==3) {
    bzero(FLOG,sizeof(FLOG));
    bcopy(argv[2],FLOG,strlen(argv[2]));
    nport=atoi(argv[1]);
  }

  //  if (argc < 2) {
  //    printf("\nuso: %s <port> <spool_file> \n\n",argv[0]);
  //    exit(1);
  //  }

 
  printf("Server Running on %s in port %i loggin on %s \n",hname,nport,FLOG);

  if ((host=gethostbyname(hname))==NULL) error(1,hname);
  socketfd = new_socket(AF_INET,SOCK_STREAM,nport,host->h_addr,1);
  listen (socketfd,MAX_PET);

  while (1) {
    cli_size=sizeof(struct sockaddr_in);
    if ((new_socketfd=
	 accept(socketfd,(struct sockaddr *)&cli_address,&cli_size))==-1) 
	   printf("<Warning> Conection refused\n");

    if ((childpid=fork())<0) error(2,NULL);
    else if (childpid==0){
	 bzero(buffer,sizeof(buffer));
	 if ((n=recvfrom(new_socketfd,&buffer,sizeof(buffer),
			 0,(struct sockaddr *)&cli_address,&cli_size))< 0) {
	     error(4,NULL);
	 }
	 parse_address(cli_address,dir2);
	 printf("(%d bytes from %s)%ld %s\n",n,dir2,id,buffer);
	 save_data(FLOG,buffer,id);
	 exit(0);
    }
    wait(NULL);
    close(new_socketfd);	  
    id++;
  }
  
}
       
